/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License 3.0 (AFL-3.0)
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to https://devdocs.prestashop.com/ for more information.
 *
 * @author    PrestaShop SA and Contributors <contact@prestashop.com>
 * @copyright Since 2007 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License 3.0 (AFL-3.0)
 */
import prestashop from 'prestashop';
import $ from 'jquery';

// TODO: kept here as a reference, to be removed in future once we have our own modal implementaion
// prestashop.blockcart.showModal = (html) => {
//   function getBlockCartModal() {
//     return $('#blockcart-modal');
//   }
//
//   let $blockCartModal = getBlockCartModal();
//
//   if ($blockCartModal.length) {
//     $blockCartModal.remove();
//   }
//
//   $('body').append(html);
//
//   $blockCartModal = getBlockCartModal();
//   $blockCartModal.modal('show').on('hidden.bs.modal', (event) => {
//     prestashop.emit('updateProduct', {
//       reason: event.currentTarget.dataset,
//       event,
//     });
//   });
// };

$(function() {
  prestashop.blockcart = prestashop.blockcart || {};
  var showModal = prestashop.blockcart.showModal || function(modal) {
      var $body = $('body');
      $body.append(modal);
      $body.one('click', '#blockcart-modal', function(event) {
          if (event.target.id === 'blockcart-modal') {
              $(event.target).remove()
          }
      })
  }
  ;
  prestashop.on('updateCart', function(event) {
      var refreshURL = $('.blockcart').data('refresh-url');
      var requestData = {};
      if (event && event.reason && typeof event.resp !== 'undefined' && !event.resp.hasError) {
          requestData = {
              id_customization: event.reason.idCustomization,
              id_product_attribute: event.reason.idProductAttribute,
              id_product: event.reason.idProduct,
              action: event.reason.linkAction
          }
      }
      if (event && event.resp && event.resp.hasError) {
          prestashop.emit('showErrorNextToAddtoCartButton', {
              errorMessage: event.resp.errors.join('<br/>')
          })
      }
      $.post(refreshURL, requestData).then(function(resp) {
        // TODO: keeping this over here, for later purposes if need be
        var html = $('<div />').append($.parseHTML(resp.preview));
        $('.blockcart').replaceWith($(resp.preview).find('.blockcart'));
        if (resp.modal) {
            showModal(resp.modal)
        }
      }).fail(function(resp) {
          prestashop.emit('handleError', {
              eventType: 'updateShoppingCart',
              resp: resp
          })
      })
  })
})
